//Turkiye Takvimi Gadget Programi 1.1
//www.turktakvim.com

// Degiskenler

// Harita Degiskenleri
var map;
var marker;
var geocoder;
var mapCenter;
var mapZoom = 8;
var qlat = 21.422514;
var qlon = 39.826122;
var cc = Math.atan(1) / 45;
var mapLat;
var mapLon;
var mapInfo;
var vakitlist;
var vakitdizi = new Array();

var hatavar = false;
var hata_kodu = 0;
var yenile = false;
//
var tip;
var aktif = 1;
var yuklendi = false;
var vakit_durumu;
var internet_durumu;
var sehir_adi;
var tarih;
var zaman;
var vakitci;
var thetime = new Date();
var vakit_list = new Array();
var vakit_hesapla_list = new Array();
var basla = false;
var harita_verileri = new Array();
var zaman_sayaci = 0;
var arzdak, arzder, arzyon;
var tuldak, tulder, tulyon;

var diziler = new Array();
var gos_ayir = new Array();

Array.prototype.ara = function(o) {
for(var i = 0; i < this.length; i++)
   if(this[i] == o)
     return true;
return false;
}

Array.prototype.temizle = function() {
for(var i = 0; i < this.length; i++){
	this.shift()
	}
}

Array.prototype.sira = function(o) {
for(var i = 0; i < this.length; i++)
	if(this[i] == o)
	return i;
return -1;
}

Array.prototype.remove = function(from, to) {
	var rest = this.slice((to || from) + 1 || this.length);
	this.length = from < 0 ? this.length + from : from;
	return this.push.apply(this, rest);
};

function ajaxkontrol (){
	if (window.XMLHttpRequest){
		//IE7+, Firefox, Chrome, Opera, Safari
		return 1;
	}else if (ActiveXObject("Msxml2.XMLHTTP")){
		//IE5
		return 1;
	}else if (ActiveXObject("Microsoft.XMLHTTP")){
		// IE6
		return 1;
		}else{
		// Ajax Destegi Yok
		return 0
	}
}

function vakitlistele(vakitdizisi){
	for (i=0; i < vakitdizisi.length; i++){
			no = (vakitdizisi[i] * 1) + 1;
			document.getElementById("v" + no).style.display = "block";
			document.getElementById(vakitdizisi[i]).checked = true;
			document.getElementById("c"+vakitdizisi[i]).style.fontWeight = "bold";
	}
}

function init() {
	//Ajax destekliyor mu
	if (ajaxkontrol() !=0){
		try{
			// Gadget
			tip = 1;
			var city_id = System.Gadget.Settings.read("SehirNo");
			//alert("Burada");
			var vakitlerr = System.Gadget.Settings.read("Vakitler");
			if (vakitlerr != null && vakitlerr != ""){
				for(m=0; m < vakitlerr.split(",").length;m++){
					vakitdizi.push(vakitlerr.split(",")[m])
				}
			}else{
				vakitdizi = ["0","1","2","3","6","7","10","12"];
				System.Gadget.Settings.write('Vakitler', vakitdizi);
			}
			if (city_id != null && city_id != ""){
				vakitleri_guncelle(city_id);
			}else{
				// Xp uzerine Gadget kuranlar icin gerekli bu satirlar.
				cid = getCookie('SehirNo');
				if (cid!=null && cid!=""){
					vakitleri_guncelle(cid);
				}else{
					vakitleri_guncelle(16741);
				}
			}
		}catch(err){
        //Browser
			tip = 2;
			var vakitlerr = getCookie("Vakitler");
			if (vakitlerr != null && vakitlerr != ""){
				for(m=0; m < vakitlerr.split(",").length;m++){
					vakitdizi.push(vakitlerr.split(",")[m])
				}
			}else{
				vakitdizi = ["0","1","2","3","6","7","10","12"];
				setCookie('Vakitler',vakitdizi,365);
			}
			cid = getCookie('SehirNo');
			if (cid!=null && cid!=""){
				vakitleri_guncelle(cid);
			}else{
				vakitleri_guncelle(16741);
			}
		}
	}else{
	//Tarayici Ajax Desteklemiyor :(
	hatavar = true;
	hata("&#304;nternet taray&#305;c&#305;n&#305;z <strong>Javascript</strong> desteklemiyor. Bu sayfay&#305; g&#246;r&#252;nt&#252;lemek i&#231;in l&#252;tfen taray&#305;c&#305;n&#305;z&#305; g&#252;ncelleyin.")
	}
}

function hata(mesaj,goster){
	hatavar = true;
	//document.getElementById("menu_basligi").style.display = "none";
	if(goster !=null){
		gos_ayir = goster.split(";");
		for (i=1; i<6; i++){
			if (!gos_ayir.ara(i))document.getElementById("menu" + i).style.display = "none";
		}
	}else{
		for (i=1; i<6; i++){
			document.getElementById("menu" + i).style.display = "none";
		}
	}
	document.getElementById("hata").style.display = "block";
	document.getElementById("uyari").innerHTML = mesaj;
}

function vakitleri_guncelle(CityID) {
	// Kisa sureligine gidiyoruz.
	$("#menu_basligi").ajaxStart(function () { $(this).hide(); });
        $("#hicri_tarih").ajaxStart(function () { $(this).hide(); });
	$("#tarih_saat").ajaxStart(function () {$(this).hide();});
	$("#prayer_vakit").ajaxStart(function () {$(this).hide();});

	// En sonunda dndk.
	$("#menu_basligi").ajaxStop(function () {
		if (internet_durumu == true) { (this).show() };
	});
	$("#hicri_tarih").ajaxStop(function () {
		if (internet_durumu == true) { (this).show() };
	});
	$("#tarih_saat").ajaxStop(function () {
		if (internet_durumu == true) { (this).show() };
	});

	$("#prayer_vakit").ajaxStop(function () {
		if (vakit_durumu == true && internet_durumu == true) { $(this).show(); }
	});

	$("#yukleniyor").ajaxStart(function () {
		$(this).show();
		$("#hata").css("display", "none");
	});

	//Ben az ciksamda islevim buyuk
	$("#yukleniyor").ajaxStart(function () {
		$(this).show();
		$("#hata").css("display", "none");
	});

	// Kaybolma Vakti
	$("#yukleniyor").ajaxStop(function () {$(this).hide();});

	$.ajax({
	    url: 'http://gadget.turktakvim.com/Default.aspx?pg=1&sid=' + CityID,
	    cache: false,
	    error: function (xhr, status) {
	        switch (xhr.status) {
	            case 500:
				//Math.
	                //Puff serverde hata var :( Hemen yneticiye bildir!!! 
					document.getElementById("hata").style.height = '222px';
	                hata("<div style='padding-top:60px;'>Serverlar&#305;m&#305;zda &#351;u anda bir s&#305;k&#305;nt&#305; var.<br /><br /><br /><br />L&#252;tfen daha sonra tekrar deneyin.<br /><div style='text-align:center; padding-top:10px;'><a href='#'>Tekrar Ba&#287;lan</a></div></div>");
	                break;
	            default:
	                //Bilgileri alamiyorum :( Internet mi koptu?
	                internet_durumu = false;
					document.getElementById("hata").style.height = '222px';
	                hata("<div style='padding-top:60px;'>L&#252;tfen &#304;nternet Ba&#287;lant&#305;n&#305;z&#305; Kontrol Edin<br /><br /><br /><a href='#' style='font-weight:bold'>Hemen Ba&#287;lan</a></div>");
	        }
	    },
	    success: function (data) {
	        //Bilgileri aldik. Iste bu super... :)
	        document.getElementById("hata").style.display = "none";
	        document.getElementById("menu_basligi").style.display = "block";
                document.getElementById("hicri_tarih").style.display = "block";
	        document.getElementById("tarih_saat").style.display = "block";
	        document.getElementById("prayer_vakit").style.display = "block";
	        document.getElementById("hicri_tarih").style.display = "block";

			//Isim zor ... ne kadar da cok veri var :)
			var veri_ayir = data.split(";");
			sehir_adi = veri_ayir[0];
			
			if (sehir_adi.length > 20){
				document.getElementById("menu_basligi").style.fontSize = '10px';
			}else{
				document.getElementById("menu_basligi").style.fontSize = '12px';
			}
			document.getElementById("menu_basligi").innerHTML = sehir_adi;
                        document.getElementById("hicri_tarih").innerHTML = veri_ayir[26];
			if (veri_ayir[7] == "VY") {
				var ayirici = veri_ayir[8].split(" ");
			}else{
				var ayirici = veri_ayir[25].split(" ");
			}
			var tarih_ayirici = ayirici[0].split(".");
			var saat_ayirici = ayirici[1].split(":");
			//thetime.setFullYear(tarih_ayirici[2], tarih_ayirici[1], tarih_ayirici[0]);
			thetime.setHours(saat_ayirici[0], saat_ayirici[1], saat_ayirici[2]);
			document.getElementById("saat").innerHTML = thetime.getHours() + ":" + thetime.getMinutes() + ":" + thetime.getSeconds();
			document.getElementById("tarih").innerHTML = ayirici[0];
			//document.getElementById("tarih").innerHTML = thetime.getDate() + "." + thetime.getMonth() + "." + thetime.getYear();
			mapLat = cevir(parseInt(veri_ayir[1]), parseInt(veri_ayir[2]), veri_ayir[3]);
			mapLon = cevir(parseInt(veri_ayir[4]), parseInt(veri_ayir[5]), veri_ayir[6]);
			mapInfo = sehir_adi;
                        if ((mapLat != 0) && (mapLon != 0)) mapZoom = 8;
			clearTimeout(vakitci);
			zamani_firlat();
			yuklendi = true;
			//mapLoad();
			basla = true;
			
			if (veri_ayir[7] == "VY") {
				//Ne kadar kuzeyde bir yer sectin. Vakitleri hesaplayamadim. bilgi@turktakvim.com'a mail ativer sana zahmet.
				hata("<div style='padding:2px;'><br /><br /><br />Se&#231;ti&#287;iniz &#351;ehrin namaz vakitleri i&#231;in l&#252;tfen bizimle e-posta ya da fax yoluyla temas kurun.<br /><br /><strong>E-Posta :</strong> <a href='mailto:bilgi@turktakvim.com' style='color:Black;'>bilgi@turktakvim.com</a><br /><br /><strong>Fax :</strong><br />+90 (212) 454 23 87</div>","2;3;5");
			}else{
				for (i = 0; i < 18; i++) {
					vakit_list[i] = veri_ayir[7 + i];
					document.getElementById("r" + (i + 1)).innerHTML = "&nbsp;" + veri_ayir[7 + i];
					if (veri_ayir[7 + i] == "00:00") { document.getElementById(i + 1).disabled = true; }
				}
				vakitlistele(vakitdizi);
				vakitle();
				vakit_belirle();
			//Cok yoruldum ama sonunda verileri ayirdim . Veri madencisi mi olsam acaba?
			}
		}
	});
}

function vkayit(){
	if (tip = 2) setCookie('Vakitler',vakitdizi,365);
}
function ZamanAl(CityID) {
	/*$.ajax({
        url: 'http://www.namazvakti.com/mahallisaat.php?cityID=' + CityID,
        cache: false,
        error: function () {
            internet_durumu = false;
            //$("#hata").css("display", "block");
            //$('div.uyari').html("L&#252;tfen &#304;nternet Ba&#287;lant&#305;n&#305;z&#305; Kontrol Edin<br /><br /><br /><a href='#' style='font-weight:bold'>Hemen Baglan</a>");
		},
		success: function (data) {
			var ayirici = data.split(" ");
			var tarih_ayirici = ayirici[0].split("/");
			var saat_ayirici = ayirici[1].split(":");
			thetime.setFullYear(tarih_ayirici[2],tarih_ayirici[1],tarih_ayirici[0]);
			thetime.setHours(saat_ayirici[0],saat_ayirici[1],saat_ayirici[2]);
			internet_durumu==true;
		}
	});*/
}

function zamani_firlat() {
	thetime.setSeconds(thetime.getSeconds() + 1);
	var csaat   = thetime.getHours();
	var cdakika = thetime.getMinutes();
	var csaniye = thetime.getSeconds();
	var csalise = thetime.getMilliseconds();
	csaat   = (csaat   < 10 ? "0" : "") + csaat;
	cdakika = (cdakika < 10 ? "0" : "") + cdakika;
	csaniye = (csaniye < 10 ? "0" : "") + csaniye;
	if (csaat == 23 && cdakika == 59 && csaniye == 59){vakitleri_guncelle(System.Gadget.Settings.read("SehirNo"));}
	document.getElementById("saat").innerHTML = csaat + ":" + cdakika + ":" + csaniye;
	if(basla == true && csaniye == 0){vakit_belirle();}
	vakitci = setTimeout("zamani_firlat()", (1000));
	zaman_sayaci++;
	if (zaman_sayaci == 300){
		if (aktif==1){
			location.reload(true);
		}else{
			yenile = true;
		}
	}
}

function vakitle(){for (i = 0; i < 14; i++) {vakit_hesapla_list[i] = vakithesapla(vakit_list[i]);}}
function vakithesapla(vakit){
	var vayir = vakit.split(":");
	vayir[1] = vayir[1] * 1 
	/* 
		Javascript beyefendi + isaretini karakter birlestirme sanmasin diye, dakikayi 1 ile carpip; "bak bu sayi, sakin string anlama" diyoruz.
		Degisken tanimlamanin kiymeti nasilda belli oluyor.
	*/
	return (vayir[0] * 60) + vayir[1];
}

function vakit_belirle (){
	var guncel_zaman = vakithesapla(thetime.getHours() + ":" + thetime.getMinutes());
	for (i = 0; i < 14; i++) {
		if (vakit_hesapla_list[i] > guncel_zaman){
			//document.getElementById("r" + i).className = "vakitli";
		}else{
		/*
		try{
			document.getElementById("r" + i).className = "vakit_d";
		}
		catch(err){
			alert(i);
		}
		*/
	}
	}
}

function tabdeg(tabno) {
	for (i = 1; i < 5; i++) {
		if (i == tabno) {
			if (!hatavar && yuklendi){
				if(tabno==1 && yenile==true){
					location.reload(true);
				}
				document.getElementById('menu' + i).style.display = 'block';
				}
			if(hatavar){
				if(gos_ayir.ara(i)){
					document.getElementById('hata').style.display = 'none';
					document.getElementById('menu' + i).style.display = 'block';
				}else{
					document.getElementById('hata').style.display = 'block';
				}
			}
			document.getElementById('mr' + i).src = i + 'a.png';
			document.getElementById("liste_menu").getElementsByTagName("li").item(i - 1).getElementsByTagName("a").item(0).className = 'aktif';
			aktif = i;
		} else {
			document.getElementById('menu' + i).style.display = 'none';
			document.getElementById('mr' + i).src = i + 'p.png'
			document.getElementById("liste_menu").getElementsByTagName("li").item(i - 1).getElementsByTagName("a").item(0).className = 'pasif';
		}
	}
}

function baslik_yaz(yazi) {
	if (yazi==1){
		if (sehir_adi.length > 20){
			document.getElementById("menu_basligi").style.fontSize = '10px';
		}else{
			document.getElementById("menu_basligi").style.fontSize = '12px';
		}
		$("#menu_basligi").html(sehir_adi);
		}else{
			document.getElementById("menu_basligi").style.fontSize = '12px';
			if (aktif==4){
				document.getElementById("menu_basligi").innerHTML = '<a href="http://turktakvim.com/index.php?link=html/masaustu_aracindaki_vakitlerin_aciklamalari.html">' + yazi + '</a>';
			}else{
				document.getElementById("menu_basligi").innerText = yazi;
			}
		}
	}

function kontrolcu(){
	var sehir_name = document.getElementById("sehir").value;
	if (sehir_name==null || sehir_name==""){
		document.getElementById("arama_sonuclari").style.display = "none";
		document.getElementById("uyari2").style.display = "block";
		document.getElementById("sehir").focus();
		}else{
		document.getElementById("uyari").style.display = "none";
		sehir_ara();
		}
}

function sehir_ara() {
    var xmlHttp;
    xmlHttp = new XMLHttpRequest();
    xmlHttp.onreadystatechange = function () {
        if (xmlHttp.readyState == 4) {
            document.getElementById("arama_sonuclari").innerHTML = xmlHttp.responseText;
            document.getElementById("arama_sonuclari").style.display = "block";
            document.getElementById("yukleniyor2").style.display = "none";
        }
        if (xmlHttp.readyState == 1) {
            document.getElementById("arama_sonuclari").style.display = "none";
            document.getElementById("yukleniyor2").style.display = "block";
        }
    }
    xmlHttp.open("Get", "http://gadget.turktakvim.com/Default.aspx?pg=2&q=" + convert_unicode(document.getElementById("sehir").value), true);
    xmlHttp.send(null);
}

function convert_unicode(source) {
    result = '';
    for (i = 0; i < source.length; i++)
        if (i == 0) {
            result += source.charCodeAt(i)
        }
        else {
            result += ";" + source.charCodeAt(i);
        }
    return result;
}

function goster_gizle(id){
	if (diziler.length > 0){
		if (diziler.ara(id))
		{
			diziler.remove(diziler.sira(id));
			//diziler.splice(diziler.sira(id),1);
			document.getElementById("di" + id).style.display = 'none';
			document.getElementById("ar" + id).src = '+.jpg';
		}else{
			diziler.push(id);
			document.getElementById("di" + id).style.display = 'block';
			document.getElementById("ar" + id).src = '-.jpg';
		}
	}else{
		diziler.push(id);
		document.getElementById("di" + id).style.display = 'block';
		document.getElementById("ar" + id).src = '-.jpg';
	}
}

function sehir_yap(id){
	try{
		System.Gadget.Settings.write("SehirNo", id);
		vakitleri_guncelle(id);
		setCookie('SehirNo',id,365);
		tabdeg(1);
		location.reload(true);
	}catch(err){
		setCookie('SehirNo',id,365);
		tabdeg(1);
		vakitleri_guncelle(id);
		//location.reload(true);
	}
}

function yap(index){
	var indexno = 0;
	var cbkontrol = document.getElementById(index);
	if (cbkontrol.checked == true){
		if(!vakitdizi.ara(index)){
			vakitdizi.push(index);
			vakitdizi.sort(sortNumber);
			indexno = (index * 1) + 1
			document.getElementById("v"+ indexno).style.display = "block";
		}
		document.getElementById("c"+index).style.fontWeight = "bold";
	}else{
		if(vakitdizi.ara(index)){
			vakitdizi.remove(vakitdizi.sira(index));
			vakitdizi.sort(sortNumber);
			indexno = (index * 1) + 1
			document.getElementById("v"+indexno).style.display = "none";
		}
		document.getElementById("c"+index).style.fontWeight = "normal";
	}

    if (tip == 1) {
        System.Gadget.Settings.write('Vakitler', vakitdizi);
    } else {
        setCookie('Vakitler', vakitdizi, 365);
    }
}

function sortNumber(a,b){
	return a - b;
}

function mapLoad() {

	myLatLng = new google.maps.LatLng(mapLat, mapLon);
	kabeiSerif = new google.maps.LatLng(21.422498, 39.826176);
	
	myOptions = {
		zoom: mapZoom,
		center: myLatLng,
		mapTypeId: google.maps.MapTypeId.ROADMAP,
		streetViewControl: false
	};

	map = new google.maps.Map(document.getElementById("map"), myOptions);

	qiblaPath = new google.maps.Polyline({
		path: [
			myLatLng,
			kabeiSerif
		],
		strokeColor: "#004F00",
		strokeOpacity: 1,
		geodesic: true,
		strokeWeight: 6
	});

	new google.maps.Marker({
		position: myLatLng,
        draggable: false,
        map: map
    });
	
    google.maps.event.addListener(map, 'idle', function() {
		google.maps.event.addListener(map, 'mouseup', function() {
			map.panTo(myLatLng);
		});		
	});

	qiblaPath.setMap(map);
}



function cevir(der, dak, yon) {
	x = der + (dak / 60);
	if (yon == 'S') x = -x;
	if (yon == 'W') x = -x;
	return x;
}

function QiblaWin() { window.open('http://www.theqibla.com/?lat='+mapLat+'&lon='+mapLon); }

function FindObj(itemx) {
	if (document.all) { return(document.all[itemx]); }
	else if (document.getElementById) { return(document.getElementById(itemx)); }
	else if (document.all.item(itemx)) { return(document.all.item(itemx)); }
	else if (document.layers) { return(document.layers[itemx]); }
	else return(false);
}


function Hesapla() {
	var bounds = map.getBounds();
	var southWest = bounds.getSouthWest();
 
	var d1 = Math.abs(distance(mapLat, mapLon, qlat, qlon));
	var d2 = Math.abs(distance(mapLat, mapLon, southWest.lat(), southWest.lng()));
	var d = Math.min(d1, d2), n = 40, delta;
 
	if (d1 > d2) { delta = 1 / n * d2/d1; } else { delta = 1 / n; }
	if (bounds.contains(new GLatLng(qlat, qlon))) delta = 1 / n;
 
	var sind = Math.sin(d1);
	var cosd = Math.cos(d1);
	var coslat1 = xcos(mapLat);
	var coslat2 = xcos(qlat);
	var sinlat1 = xsin(mapLat);
	var sinlat2 = xsin(qlat);
	var coslon1 = xcos(mapLon);
	var coslon2 = xcos(qlon);
	var sinlon1 = xsin(mapLon);
	var sinlon2 = xsin(qlon);
 
	var points = []; points.push(mapCenter);
 
	for (var i = 1; i <= n; i++) {
		var f = i*delta;
		var A = Math.sin((1-f)*d1)/sind;
		var B = Math.sin(f*d1)/sind;
		var x = A * coslat1 * coslon1 +  B * coslat2 * coslon2;
		var y = A * coslat1 * sinlon1 +  B * coslat2 * sinlon2;
		var z = A * sinlat1           +  B * sinlat2;
		var lat = Math.atan2(z,Math.sqrt(Sqr(x)+Sqr(y)))/cc;
		var lon = Math.atan2(y,x)/cc;
		points.push(new GLatLng(lat, lon));
	}
	return points;
}
function xsin(x) 	{ return Math.sin(x*cc); }
function xcos(x) 	{ return Math.cos(x*cc); }
function Sqr(x) 	{ return x*x; }
function distance (a1, t1, a2, t2) { return (2 * Math.asin( Math.sqrt(Sqr(xsin((a1-a2)/2)) + xcos(a1)*xcos(a2)*Sqr(xsin((t1-t2)/2))))); }
function cevir(der, dak, yon) {
	x = der + (dak / 60);
	if (yon == 'S') x = -x;
	if (yon == 'W') x = -x;
	return x;
}
function ss2(x) { x = "0" + x; return x.substr(x.length-2); };
function toDMS(x, v1, v2) {
	var p = v1;
	if (x < 0) p = v2;
	
	x = Math.abs(x);
	var dd = x * 3600;
	var ii = Math.floor(dd);
	
	var d = Math.floor(x);
	var m = Math.floor((ii - 3600*d)/60);
	var s = ii - 3600*d - 60*m;
	var ss = Math.floor((dd - ii)*100);
	
	return d + " " + ss2(m) + "' " + ss2(s) + "." + ss2(ss) + '" ' + p;
}
function toTZ(x, v1, v2) {
	var p = v1;
	if (x < 0) p = v2;
	
	x = Math.abs(x);
	var dd = x * 3600;
	var ii = Math.floor(dd);
	
	var d = Math.floor(x);
	var m = Math.floor((ii - 3600*d)/60);
	var s = ii - 3600*d - 60*m;
	var ss = Math.floor((dd - ii)*100);
 
	var tz = parseInt(d * 60) + parseInt(ss2(m));
	tz = (tz /15); if (p == 'W') tz = -1*tz;
	return tz;
}
//:) :) :)
window.onerror = function(){
	return true;
}

function setCookie(c_name,value,expiredays)
{
	var exdate=new Date();
	exdate.setDate(exdate.getDate()+expiredays);
	document.cookie=c_name+ "=" +escape(value)+
	((expiredays==null) ? "" : ";expires="+exdate.toUTCString());
}

function getCookie(c_name)
{
if (document.cookie.length>0)
  {
  c_start=document.cookie.indexOf(c_name + "=");
  if (c_start!=-1)
    {
    c_start=c_start + c_name.length+1;
    c_end=document.cookie.indexOf(";",c_start);
    if (c_end==-1) c_end=document.cookie.length;
    return unescape(document.cookie.substring(c_start,c_end));
    }
  }
return "";
}